package com.bria.common.controller.calllog

import com.bria.common.controller.calllog.db.CallLogEntity
import com.bria.common.controller.calllog.db.CallType
import io.reactivex.Flowable
import io.reactivex.Maybe
import io.reactivex.Single

/**
 * Note, all Rx operations of this API always work on IO thread
 * So you can avoid to explicit call subscribeOn(Schedulers.io())
 */
interface CallLogApi {
    fun put(vararg entities: CallLogEntity): Single<List<Long>>

    fun get(id: Long): Maybe<CallLogEntity?>

    fun getLast(callType: CallType): Maybe<CallLogEntity?>

    fun getAll(): Flowable<List<CallLogEntity>>

    fun delete(vararg entities: CallLogEntity): Single<Unit>

    fun delete(callType: CallType): Single<Unit>

    fun deleteAll(): Single<Unit>

    fun markAllRead(): Single<Unit>

    fun getCountOfUnreadMissedCalls(): Flowable<Int>

    fun destroy()
}
