package com.bria.common.controller.calllog.db

import android.arch.persistence.room.ColumnInfo
import android.arch.persistence.room.Entity
import android.arch.persistence.room.Ignore
import android.arch.persistence.room.PrimaryKey

@Entity(tableName = "calllog")
data class CallLogEntity(
        @PrimaryKey(autoGenerate = true)
        @ColumnInfo(name = "id") var id: Long = 0,
        @ColumnInfo(name = "number") override var number: String = "",
        @ColumnInfo(name = "callType") override var callType: CallType = CallType.INCOMING,
        @ColumnInfo(name = "date") override var date: Long = System.currentTimeMillis(),
        @ColumnInfo(name = "durationSeconds") override var durationSeconds: Int = 0,
        @ColumnInfo(name = "provisioningUser") override var provisioningUser: String = "",
        @ColumnInfo(name = "accountId") override var accountId: Int = -1,
        @ColumnInfo(name = "accountUsername") override var accountUsername: String = "",
        @ColumnInfo(name = "accountDomain") override var accountDomain: String = "",
        @ColumnInfo(name = "remoteDomain") override var remoteDomain: String = "",
        @ColumnInfo(name = "remoteName") override var remoteName: String = "",
        @ColumnInfo(name = "recordFileName") override var recordFileName: String = "",
        @ColumnInfo(name = "forwardedTo") override var forwardedTo: String = "",
        @ColumnInfo(name = "hostedCollab") override var hostedCollab: Boolean = false,
        @ColumnInfo(name = "externalId") override var externalId: String = "",
        @ColumnInfo(name = "unread") override var unread: Boolean = true
    ) : CallLog {

    @Ignore
    constructor(callLog: CallLog) : this(
            number = callLog.number,
            callType = callLog.callType,
            date = callLog.date,
            durationSeconds = callLog.durationSeconds,
            provisioningUser = callLog.provisioningUser,
            accountId = callLog.accountId,
            accountUsername = callLog.accountUsername,
            accountDomain = callLog.accountDomain,
            remoteDomain = callLog.remoteDomain,
            remoteName = callLog.remoteName,
            recordFileName = callLog.recordFileName,
            forwardedTo = callLog.forwardedTo,
            hostedCollab = callLog.hostedCollab,
            externalId = callLog.externalId,
            unread = callLog.unread
    )
}
