package com.bria.common.controller.contacts

import com.bria.common.util.CrashInDebug

enum class ContactNamesArrangement(val rawValue: Int) {
    FirstNameThenLastName(1),
    LastNameThenFirstName(2);

    companion object {
        const val TAG = "ContactNamesArrangement"

        fun fromRawIntValue(intValue: Int): ContactNamesArrangement =
                when (intValue) {
                    1 -> FirstNameThenLastName
                    2 -> LastNameThenFirstName
                    else -> {
                        CrashInDebug.with(TAG, "Unknown value: $intValue")

                        FirstNameThenLastName
                    }
                }
    }
}
