package com.bria.common.controller.contacts

import com.bria.common.util.CrashInDebug

enum class ContactsSortBy(val rawValue: Int) {
    FirstName(1),
    LastName(2);

    companion object {
        const val TAG = "ContactsSortBy"

        fun fromRawIntValue(intValue: Int): ContactsSortBy =
                when (intValue) {
                    1 -> FirstName
                    2 -> LastName
                    else -> {
                        CrashInDebug.with(TAG, "Unknown value: $intValue")

                        FirstName
                    }
                }
    }
}
