package com.bria.common.controller.contacts.buddy.v2

import com.bria.common.controller.Controllers
import com.bria.common.controller.buddy.BuddyAvailability
import com.bria.common.controller.contacts.buddy.Buddy
import com.bria.common.controller.contacts.buddy.IBuddyCtrlEvents
import com.bria.common.modules.BriaGraph
import com.bria.common.uireusable.dataprovider.AbstractFilterableListDataProvider
import com.bria.common.uireusable.dataprovider.FilterQueryMatcher

class BuddyDataProvider : AbstractFilterableListDataProvider<Buddy>() {

    override fun provideFullDataSet(): List<Buddy> {
        val online = Controllers.get().buddy.buddyFilterType == IBuddyCtrlEvents.EBuddyFilterType.ONLINE
        val buddyAvailability = if (online) BuddyAvailability.Online else BuddyAvailability.All

        return Controllers.get().buddy.getListOfBuddiesSorted(Buddy.EBuddyType.ALL, buddyAvailability)
            .filter { x -> !BriaGraph.teams.isBuddyFromTeam(x) }
    }

    override fun provideFilteredDataSet(fullDataSet: List<Buddy>, query: String): List<Buddy> {
        val filterQueryMatcher = FilterQueryMatcher(query)

        return fullDataSet
            .filter { filterQueryMatcher.isMatch(it.firstName, it.lastName) }
            .toMutableList()
    }
}
