package com.bria.common.controller.contacts.buddy.v2

import com.bria.common.controller.buddy.BuddyAvailability
import com.bria.common.controller.presence.IPresenceCtrlEvents
import com.bria.common.controller.presence.IPresenceCtrlObserver
import com.bria.common.controller.presence.OwnPresence
import com.bria.common.controller.presence.refactoring.EPresenceStatus
import com.bria.common.uireusable.dataprovider.AbstractFilterableListDataProvider
import com.bria.common.uireusable.dataprovider.IContactActionDataProvider
import com.bria.common.uireusable.dataprovider.IExtendedFilterableDataProvider
import com.bria.common.uireusable.datatypes.IPersonListItem
import com.bria.common.util.IObservable

class BuddyRequestDataProviderV2(val mIPresenceCtrlEvents: IPresenceCtrlEvents, val mIPresenceCtrlObserver: IObservable<IPresenceCtrlObserver>) : AbstractFilterableListDataProvider<IPersonListItem>(), IContactActionDataProvider<IPersonListItem>, IPresenceCtrlObserver {

    init {
        mIPresenceCtrlObserver.attachWeakObserver(this)
    }

    override fun filterDataProvider(subFilter: BuddyAvailability?) {
    }

    override fun provideFullDataSet(): List<IPersonListItem> {
       return mIPresenceCtrlEvents.buddyRequestsList
    }

    override fun provideFilteredDataSet(fullDataSet: List<IPersonListItem>, query: String): List<IPersonListItem> {
        return mIPresenceCtrlEvents.buddyRequestsList
    }

    override fun removeActiveItem(position: Int?) {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun initializeLoadingData() {
        initialize()
    }

    override fun filterDataProvider(query: CharSequence) {
    }

    override fun attachWeakListenerV2(iExtendedFilterableDataProvider: IExtendedFilterableDataProvider) {
        attachWeakListener(iExtendedFilterableDataProvider)

    }

    // BUDDY REQUEST EVENTS
    override fun onRemoteEndPresenceChanged(accId: String?, remoteAddr: String?, presenceStatus: EPresenceStatus?, presenceMsg: String?) {
    }

    override fun onPresenceUpdate(presence: OwnPresence?, previousPresence: OwnPresence?) {
    }

    override fun onSubscriptionRequest() {
    }

    override fun onBuddyRequestNumberChanged(newRequestCount: Int, allRequestsCount: Int) {
        refilter()
    }
}
