package com.bria.common.controller.contacts.local

import android.Manifest
import android.content.Context
import android.provider.ContactsContract
import com.bria.common.permission.PermissionHandler
import com.bria.common.util.Log

object AndroidContactUtils {
    private val TAG = "AndroidContactUtils"

    fun findContactByFirstName(context: Context, firstName: String): String? {
        if (!PermissionHandler.checkPermission(context, Manifest.permission.READ_CONTACTS)) {
            Log.w(TAG, "READ_CONTACTS permission not granted.")
            return null
        }

        context.contentResolver.query(
                ContactsContract.Data.CONTENT_URI,
                arrayOf(ContactsContract.Data.CONTACT_ID),
                "${ContactsContract.CommonDataKinds.StructuredName.GIVEN_NAME} = ?",
                arrayOf(firstName),
                null)
            .use { cursor ->
                if (cursor != null && cursor.moveToFirst()) {
                    return cursor.getString(0)
                } else {
                    return null
                }
            }
    }
}
