package com.bria.common.controller.coordinatedevents

import android.os.Bundle
import com.bria.common.util.Log

/**
 * Means of communication between controllers and presenters. Not vice versa.
 * */
class CoordinatedEventAggregator : ICoordinatedEventAggregatorPublishSide, ICoordinatedEventAggregatorListenerSide {

    private val TAG = "CoordinatedEventAggregator"

    private var mListener: CoordinatedEventListener? = null

    override fun setCoordinatedEventListener(listener: CoordinatedEventListener?) {
        mListener = listener
    }

    override fun removeCoordinatedEventListener(listener: CoordinatedEventListener?) {
        if (mListener === listener) {
            mListener = null
        }
    }

    override fun sendCoordinatedEvent(eventType: CoordinatedEventType, eventData: Bundle?) {
        Log.d(TAG, "Sending $eventType, data: $eventData")

        mListener?.onCoordinatedEvent(eventType, eventData)
    }
}
