package com.bria.common.controller.im.refactoring

import com.bria.common.uireusable.datatypes.ExtendedConversationData

class DraftInstantMessages {
    private val im = mutableMapOf<Long, String>()
    private val chatRoom = mutableMapOf<Long, String>()

    fun store(conversationData: ExtendedConversationData, draftMessage: String) {
        if (conversationData.isCreated()) {
            if (conversationData.isChatRoom()) {
                chatRoom.put(conversationData.getId(), draftMessage)
            } else {
                im[conversationData.getId()] = draftMessage
            }
        }
    }

    fun retrieve(conversationData: ExtendedConversationData): String {
        if (conversationData.isCreated()) {
            if (conversationData.isChatRoom()) {
                return chatRoom.get(conversationData.getId()) ?: ""
            } else {
                return im.get(conversationData.getId()) ?: ""
            }
        }

        return ""
    }

}
