package com.bria.common.controller.im.refactoring.adapter

import com.bria.common.controller.contacts.buddy.XmppBuddy

data class ChunkedString<TTag>(private val chunks: List<Chunk<TTag>>) : Iterable<ChunkedString.Chunk<TTag>> {
    override fun iterator(): Iterator<Chunk<TTag>> {
        return chunks.iterator()
    }

    data class Chunk<TTag>(val text: String, val tag: TTag?)
}

sealed class PlainTextOrMentionChunk(open val text: String) {
    data class HardcodedMention(override val text: String) : PlainTextOrMentionChunk(text)
    data class BuddyMention(override val text: String, val buddy: XmppBuddy) : PlainTextOrMentionChunk(text)
    data class PlainText(override val text: String) : PlainTextOrMentionChunk(text)
}
