package com.bria.common.controller.im.refactoring.chatroom

import com.bria.common.controller.im.refactoring.roomdb.entities.ChatRoom
import com.bria.common.controller.im.refactoring.roomdb.entities.Message
import com.bria.common.util.CrashInDebug

object LoggedInUserMentionDetector {
    const val TAG = "LoggedInUserMentionDetector"

    @JvmStatic
    fun isLoggedInUserMentioned(instantMessageData: Message?, chatRoom: ChatRoom): Boolean {
        // java...
        if (instantMessageData == null) {
            CrashInDebug.with(TAG, "message is null")
            return false
        }

        if (chatRoom.accountId.isBlank()) {
            CrashInDebug.with(TAG, "username is empty")
            return false
        }

        val mentions = MentionsFinder.findMentions(instantMessageData.text)
        var account = chatRoom.accountId
        account = account.substringBefore('@')
        val atUsername = "@" + account
        for (mention in mentions) {
            val mentionText = instantMessageData.text.substring(mention.start, mention.start + mention.length)
            if (mentionText.equals(WellKnowMention.Everyone.atText, true)) {
                return (chatRoom.joinTime - instantMessageData.creationTime) < 0
            }

            if (mentionText.equals(atUsername, true)) {
                return true
            }
        }

        return false
    }
}
