package com.bria.common.controller.im.refactoring.chatroom.joinedroom

import com.bria.common.controller.im.ImpsUtils

data class JoinedRoomData(var roomId: String = "",
                          var roomCreator: String = "",
                          var joinTime: Long = 0,
                          var lastViewed: Long = 0,
                          var lastViewedMsgId: String = "",
                          var roomName: String = "",
                          val undefinedElements: HashMap<String, String> = HashMap()
) {


    fun hasSameChatKey(chatKey : String) = if (this.roomId.contains("@") xor chatKey.contains("@")) {
        ImpsUtils.removeDomainFromAddress(this.roomId) == ImpsUtils.removeDomainFromAddress(chatKey)
    } else this.roomId == chatKey
}
