package com.bria.common.controller.im.refactoring.chatroom.joinedroom

import com.counterpath.sdk.handler.XmppAccountHandler
import io.reactivex.subjects.Subject

interface JoinedRoomSyncApi : XmppAccountHandler {
    fun fetchAndUpdate()
    fun addJoinedRoom(room : JoinedRoomData)
    fun removeJoinedRoom(room : JoinedRoomData)
    fun destroy()
    fun joinRoomsListChangedObservable() : Subject<List<JoinedRoomData>>
    fun addJoinedRooms(rooms: List<JoinedRoomData>)
    fun updateField(newField: Pair<String, Pair<JoinRoomStorageField, String>>)
    fun updateFields(newFields: List<Pair<String, Pair<JoinRoomStorageField, String>>>)
    fun getLastViewedMessageTimeInMs(chatKey: String): Long
    fun getMessageIdOfLastViewedMessage(chatKey: String): String
    fun isAlreadyRead(chatKey: String, time: Long): Boolean
}
