package com.bria.common.controller.im.refactoring.chatroom.utils

import com.bria.common.controller.im.refactoring.BuddyKeyUtils
import com.bria.common.controller.im.refactoring.chatroom.ChatRoomApi
import com.bria.common.controller.im.refactoring.roomdb.ChatRoomRepo
import com.bria.common.controller.im.refactoring.roomdb.entities.ChatRoom
import com.bria.common.controller.im.refactoring.roomdb.entities.ChatRoomState
import com.bria.common.controller.settings.branding.EAccountType
import com.bria.common.uireusable.datatypes.ExtendedConversationData
import com.bria.common.util.im.ParticipantsSet
import com.counterpath.sdk.XmppAccount
import io.reactivex.Single
import io.reactivex.schedulers.Schedulers

object ChatRoomUtils {

    fun createPublicRoomCPTESTXAndAdd301Messages(api: ChatRoomApi,repo: ChatRoomRepo, userAtDomain: String): Single<Boolean> {
        return Single.fromCallable {
            val time = System.currentTimeMillis()
            val chatRoom = ChatRoom(name = "CPTESTX${time}",
                    type = ExtendedConversationData.CHAT_ROOM_TYPE.toLong(),
                    accountId = userAtDomain,
                    description = "CPTESTX descripton",
                    owners = ParticipantsSet(BuddyKeyUtils.getNewBuddyKey(EAccountType.Xmpp, userAtDomain, userAtDomain)),
                    publicRoom = true,
                    modTime = time,
                    creationTime = time,
                    state = ChatRoomState.ACTIVE)
            api.createRoom(chatRoom)
            val list = repo.getOnRoomAddedObservable().filter { it.firstOrNull { itemRoom -> itemRoom.name == chatRoom.name } != null }.blockingFirst()
            val addedRoom = list.firstOrNull { it.name == chatRoom.name }
            if (addedRoom != null) {
                (1..301).forEach { messageNo ->
                    api.sendMessage(addedRoom, messageNo.toString())
                    Thread.sleep(500)
                }
                true
            } else {
                false
            }

        }.subscribeOn(Schedulers.newThread())
    }

    private fun send301Messages(chatRoom: ChatRoom, account: XmppAccount) {
//        val
//        Observable.interval(10, 500, TimeUnit.MILLISECONDS).take(301)

    }
}
