package com.bria.common.controller.presence

import android.content.Context
import android.graphics.drawable.Drawable
import android.util.Pair
import com.bria.common.controller.contacts.buddy.IBuddyCtrlEvents
import com.bria.common.controller.contacts.buddy.repository.EBuddyType

open class BuddyPresenceMatcher(val context: Context, val buddyCtrlEvents: IBuddyCtrlEvents) : IPresenceMatcher {


    override fun getPresence(id: String?): BuddyPresence? {
        val buddy = buddyCtrlEvents.getBuddyByNewKey(id)
        return if (buddy?.presence == null) return null else buddy.presence
    }


    override fun getPresenceResources(id: String): Pair<Drawable, String> {
        if (id.contains(EBuddyType.SIP.name, false) || id.contains(EBuddyType.XMPP.name, false)) {
            //XMPP BUDDY + SIP BUDDY(ALL + ONLINE)
            val xmppBuddy = buddyCtrlEvents.getXmppBuddyByPhoneNumber(id)
            val buddy = buddyCtrlEvents.getBuddyByNewKey(id) ?: return Pair<Drawable, String>(null, null)
            val presence = buddy.presence ?: return Pair<Drawable, String>(null, null)
            val status = presence.status ?: return Pair<Drawable, String>(null, null)
            val icon = status.getIcon(context)
            val presenceNote = presence.getPresenceNote(context)
            return Pair<Drawable, String>(icon, presenceNote)
        } else {
            //BuddyRequest
            return Pair<Drawable, String>(null, id)

        }

    }

}
