package com.bria.common.modules.android

import android.app.Application
import com.bria.common.util.CrashInDebug

class AppLifetimeReceivers(
        private val application: Application,
        private val backgroundForegroundScreenOffReceiver: BackgroundForegroundScreenOffReceiver,
        private val screenOnOffReceiver: ScreenOnOffReceiver) {

    private val LOG_TAG = "AppLifetimeReceivers"

    fun register() {
        application.registerReceiver(backgroundForegroundScreenOffReceiver, BackgroundForegroundScreenOffReceiver.intentFilter)
        application.registerReceiver(screenOnOffReceiver, ScreenOnOffReceiver.intentFilter)
    }

    fun unregister() {
        try {
            application.unregisterReceiver(backgroundForegroundScreenOffReceiver)
        } catch (throwable: Throwable) {
            CrashInDebug.with(LOG_TAG, throwable)
        }

        try {
            application.unregisterReceiver(screenOnOffReceiver)
        } catch (throwable: Throwable) {
            CrashInDebug.with(LOG_TAG, throwable)
        }
    }
}
