package com.bria.common.ui

import android.content.Context
import android.graphics.drawable.Drawable
import android.support.annotation.ColorInt
import android.support.annotation.ColorRes
import android.support.v4.content.ContextCompat

fun Drawable.tintWithColorRes(context: Context, @ColorRes id: Int): Drawable {
    val color = ContextCompat.getColor(context, id)
    val result = this.tintWithColorProper(color)

    return result
}

fun Drawable.tintWithColorProper(@ColorInt color: Int): Drawable {

    // do not affect other users of this drawable
    this.mutate()

    this.setTint(color)

    return this
}
