package com.bria.common.ui.util

import android.text.SpannableStringBuilder
import android.text.style.ForegroundColorSpan
import android.widget.TextView

class SearchQueryColorizer(highlightColor: Int) {

    private val mForegroundColorSpan: ForegroundColorSpan = ForegroundColorSpan(highlightColor)

    fun colorize(textView: TextView, queryToken: String) {
        val text = textView.text.toString()

        if (text.isBlank() || queryToken.isEmpty()) {
            return
        }

        val index = text.toLowerCase().indexOf(queryToken.toLowerCase())
        if (index >= 0) {
            val spannableStringBuilder = SpannableStringBuilder(text)
            spannableStringBuilder.setSpan(mForegroundColorSpan, index, index + queryToken.length, 0)
            textView.text = spannableStringBuilder
        }
    }
}
