package com.bria.common.uireusable.dataprovider

class FilterQueryMatcher(query: String?) {
    val queryTokens = tokenize(query ?: "")

    /*
    * Matches when all tokens from query are present in at least one of the strings to match.
    * */
    fun isMatch(vararg stringsToMatch: String): Boolean {
        val stringsToMatchTokens = stringsToMatch.flatMap { tokenize(it) }

        for (queryToken in queryTokens) {
            val queryTokenIsPresentInStringsToMatch = stringsToMatchTokens.any { it.startsWith(queryToken) }

            if (!queryTokenIsPresentInStringsToMatch) {
                // query token not found

                return false
            }
        }

        return true
    }

    private fun tokenize(string: String?): List<String> {
        if (string == null) {
            return listOf()
        }

        return string
            .toLowerCase()
            .split("\\s+".toRegex())
            .filter { it.isNotEmpty() }
    }
}
