package com.bria.common.util

interface ICollectionChangeObserver<T> {

    /**
     * Item has been added to collection.
     * */
    fun itemAdded(item: T)

    /**
     * Item has been removed from collection.
     * */
    fun itemRemoved(item: T)

    /**
     * Item has changed its content.
     * */
    fun itemChanged(item: T)

    /**
     * Big part of collection has changed or unknown changes have happened.
     * */
    fun collectionChanged()
}
