package com.bria.common.util

sealed class Result<TSuccess, TFailure> {
    data class Success<TSuccess, TFailure>(val value: TSuccess) : Result<TSuccess, TFailure>()
    data class Failure<TSuccess, TFailure>(val value: TFailure) : Result<TSuccess, TFailure>()
}

fun <TSuccess, TFailure> succeedWith(value: TSuccess): Result<TSuccess, TFailure> {
    return Result.Success(value)
}

fun <TSuccess, TFailure> failWith(value: TFailure): Result<TSuccess, TFailure> {
    return Result.Failure(value)
}
