package com.bria.common.util.phone

import com.bria.common.controller.accounts.IAccountsCtrlActions
import com.bria.common.controller.settings.EAccountSetting
import com.bria.common.controller.settings.ESetting
import com.bria.common.controller.settings.ISettingsReader

class SingleTouchToCallHelper(
        private val settings: ISettingsReader<ESetting>,
        private val accountsCtrl: IAccountsCtrlActions) {

    fun shouldCallOnSingleTouch(): Boolean {
        val account = accountsCtrl.getPrimaryAccount()
        if (account == null) {
            return false
        }

        val singleTouchToCall = settings.getBool(ESetting.SingleTouchtoCall)
        val smsEnabled = account.getBool(EAccountSetting.IsSMS) && settings.getBool(ESetting.Sms)
        val prefixCallEnabled = settings.getBool(ESetting.FeatureCustomPrefixCalling) && settings.getBool(ESetting.CustomPrefixCallingEnabled)

        if (singleTouchToCall
                && !smsEnabled
                && !prefixCallEnabled
                && (!accountsCtrl.isVideoEnabled(account) || account.getBool(EAccountSetting.AlwaysOfferVideo))) {

            return true
        }

        return false
    }
}
