package com.bria.voip

import com.bria.common.controller.contacts.ContactsSortBy
import com.bria.common.controller.settings.ESetting
import com.bria.common.modules.BriaGraph
import com.bria.voip.ui.main.contacts.BriaXContactsListTeamBuddiesDataProvider
import com.bria.voip.ui.main.im.chatroom.members.ChatRoomMembersDataProvider
import com.bria.voip.ui.main.im.chatroom.mentions.ChatRoomMentionsAdapter

object BriaSipGraph {

    // transient
    fun chatRoomMentionsAdapter(): ChatRoomMentionsAdapter {
        return ChatRoomMentionsAdapter(
                BriaGraph.application,
                BriaGraph.settings,
                BriaGraph.buddyCtrl,
                BriaGraph.buddyObservable,
                BriaGraph.chatRoomRepo,
                BriaGraph.chatRoomApi)
    }

    fun briaXContactsListTeamBuddiesDataProvider(): BriaXContactsListTeamBuddiesDataProvider {
        return BriaXContactsListTeamBuddiesDataProvider(
                BriaGraph.buddyCtrl,
                BriaGraph.buddyObservable,
                BriaGraph.teams)
    }

    fun chatRoomMembersDataProvider(): ChatRoomMembersDataProvider {
        return ChatRoomMembersDataProvider(
                BriaGraph.buddyCtrl,
                ContactsSortBy.fromRawIntValue(BriaGraph.settings.getInt(ESetting.ContactSortOrder)),
                BriaGraph.buddyObservable)
    }
}
