package com.bria.voip.ui.main.calllog.refactoring

import android.os.Bundle
import android.support.annotation.MainThread
import com.bria.common.uiframework.annotations.Layout
import com.bria.common.uiframework.presenters.IPresenterEvent
import com.bria.voip.R

@Layout(R.layout.calllog_list_screen)
class CallLogDetailsScreen : CallLogAbstractScreen<CallLogDetailsPresenter>() {
    companion object {
        private const val TAG = "CallLogDetailsScreen"
    }

    override fun onPresenterEvent(event: IPresenterEvent<*, *>) {
        super.onPresenterEvent(event)

        when (event.type) {
            CallLogDetailsPresenter.Events.GO_UP -> mCoordinator.flow().goUp()
        }
    }

    override fun getPresenterClass() = CallLogDetailsPresenter::class.java

    @MainThread
    override fun onCreate(bundle: Bundle?) {
        super.onCreate(bundle)
        mIgnoreUpButton = true
        mAdapter.onItemDeleteRecordButtonClickListener = { _, position -> presenter.onItemDeleteCallRecordButtonClicked(position) }
        mAdapter.onItemSaveRecordButtonClickListener = { _, position -> presenter.onItemSaveCallRecordButtonClicked(position) }
        mAdapter.onItemShareRecordButtonClickListener = { _, position -> presenter.onItemShareCallRecordButtonClicked(position) }
        mAdapter.onItemPlayRecordButtonClickListener = { _, position -> presenter.onItemPlayCallRecordButtonClicked(position) }
    }

    @MainThread
    override fun onStart(bundle: Bundle?) {
        super.onStart(bundle)
        presenter.onScreenStart(bundle)
    }
}
