package com.bria.voip.ui.main.calllog.refactoring.broadworks

import com.bria.common.controller.calllog.db.CallLogEntity
import com.bria.common.util.Log
import com.bria.voip.ui.main.calllog.refactoring.CallLogListPresenter
import io.reactivex.disposables.Disposable
import io.reactivex.rxkotlin.subscribeBy

class BroadWorksCallLogListPresenter: CallLogListPresenter() {
    companion object {
        private const val TAG = "BroadWorksCallLogListPresenter"
    }

    private var mDisposable: Disposable? = null

    fun onScreenResumed() {
        // Small hack to reload data. BW realization of put() method just request new data from the server
        mDisposable?.dispose()
        mDisposable = mCallLogApi.put(CallLogEntity()).subscribeBy(onError = { Log.w(TAG, "Error ", it) })
    }

    override fun onUnsubscribe() {
        super.onUnsubscribe()
        mDisposable?.dispose()
    }

    override fun onDestroy() {
        super.onDestroy()
        mDisposable?.dispose()
    }

    override fun isMenuAddContactEnabled(position: Int) = false

    override fun isMenuUpdateContactEnabled(position: Int) = false

    override fun isMenuSendImEnabled(position: Int) = false

    override fun isMenuTransferCallEnabled(position: Int) = false
}
