package com.bria.voip.ui.main.im.chatroom.join

import com.bria.common.controller.im.refactoring.roomdb.ChatRoomRepo
import com.bria.common.controller.im.refactoring.roomdb.LocalRoomInfo
import com.bria.common.uireusable.dataprovider.AbstractFilterableListDataProvider

class JoinRoomsDataProvider(
        private val chatRoomRepo: ChatRoomRepo)
    : AbstractFilterableListDataProvider<LocalRoomInfo>() {

    var activeList = listOf<LocalRoomInfo>()

    override fun provideFullDataSet(): List<LocalRoomInfo> {
        activeList = chatRoomRepo.getServerRoomList("", false, true)

        return activeList
    }

    override fun provideFilteredDataSet(fullDataSet: List<LocalRoomInfo>, query: String): List<LocalRoomInfo> {
        activeList = chatRoomRepo.getServerRoomList(query, false, true)

        return activeList
    }

    fun getByRoomKey(key: String): LocalRoomInfo? {
        return activeList.firstOrNull { it.cleanedJid == key }
    }

}
