package com.bria.voip.ui.shared.helpers

import android.view.View
import com.bria.common.util.CrashInDebug

val View.isVisible: Boolean
    get() = when (visibility) {
        View.VISIBLE -> true
        View.GONE -> false
        View.INVISIBLE -> {
            CrashInDebug.with("ViewExtensions", "Invisible is not supported")
            false
        }
        else -> {
            CrashInDebug.with("ViewExtensions", "Value $visibility is not supported")
            true
        }
    }

fun View.setVisible(value: Boolean) {
    visibility = if (value) {
        View.VISIBLE
    } else {
        View.GONE
    }
}
